package com.sece.android;

import android.content.Context;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.widget.Toast;

/*
 The implementation of the PhoneStateListener, which will be
 used to send the update XML information to the SECE server whenever
 the phone state has been changed. The phone state machine is implemented
 in the switch statement as follows.
 */
public class MyPhoneStateListener extends PhoneStateListener {

	
    public String phonenumber;
    public Context context;
    private String XML;
    private String Repeat1=null;
    
    
	
	public MyPhoneStateListener(String number, Context cont){
		context=cont;
		phonenumber = number;
		
	}
	
	
	public void onCallStateChanged(int state,String incomingNumber){
		//state machine
		//Total three states IDLE, OFFHOOK, RINGING
		switch(state){
//current state		
		    case TelephonyManager.CALL_STATE_IDLE:		      
		    	Log.d("DEBUG", "IDLE");
		    	Toast.makeText(context, "Back to IDLE Status", Toast.LENGTH_SHORT).show();
		   //previous state
		    	switch(GlobalRecord.PreviousState){
		         
		    	   case TelephonyManager.CALL_STATE_IDLE:		        	         	   
		        	   Toast.makeText(context, "Nothing", Toast.LENGTH_SHORT).show(); 
		        	   break;
		          
		           case TelephonyManager.CALL_STATE_OFFHOOK:
		        	   XML=GlobalRecord.XML1 + 
		        	   "version=\""+ ++GlobalRecord.Version +"\"\n" + 
	        	       "state=\"full\"\n" +
	        	       "entity=\"tel:+"+phonenumber+"\">\n" + 	        	       
                       "</dialog-info>\n";
	        	   System.out.print(XML);
	        	   try{
	          	     PhoneStateService.sipLayer.sendMessage(XML);	
	          	    }
	          	     catch(Throwable e){
	          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
	          	     }
		        	   Toast.makeText(context, "OFFHOOK Over", Toast.LENGTH_SHORT).show();
		        	   break;
		           
		           case TelephonyManager.CALL_STATE_RINGING:
		        	 
		        	   XML=GlobalRecord.XML1 +
		        	   Repeat( ++GlobalRecord.Version,++GlobalRecord.Dialog_id,phonenumber) + 
	        	       "direction=\"recipient\">\n" + 
	        	       "<state>terminated</state>\n" + 
	        	       "<remote>\n" + 
	        	       "<identity>tel:+"+incomingNumber+"</identity>\n" + 
	        	       " </remote>\n" + 
	        	       "</dialog>\n" +
                       "</dialog-info>\n";
	        	   System.out.print(XML);
	        	   try{
	          	     PhoneStateService.sipLayer.sendMessage(XML);	
	          	    }
	          	     catch(Throwable e){
	          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
	          	     }
		        	   Toast.makeText(context, "CUT OFF", Toast.LENGTH_SHORT).show();
		    	  break;
		      }
		    break;
		    
		    case TelephonyManager.CALL_STATE_OFFHOOK:
		      Log.d("DEBUG", "OFFHOOK");
		      Toast.makeText(context, "OFFHOOK Status", Toast.LENGTH_SHORT).show();		     
		      switch(GlobalRecord.PreviousState){
	         
		       case TelephonyManager.CALL_STATE_IDLE:	       	  
	        	   XML=GlobalRecord.XML1 + 
	        	   Repeat( ++GlobalRecord.Version,++GlobalRecord.Dialog_id,phonenumber)  + 
        	       "direction=\"initiator\">\n" + 
        	       "<state>confirmed</state>\n" +
        	       "<remote>\n" + 
        	       "<identity>tel:+" + GlobalRecord.outgoingNumber +"</identity>\n" + 
        	       " </remote>\n" + 
        	       "</dialog>\n" +
                   "</dialog-info>\n";
        	   System.out.print(XML);
        	   try{
          	     PhoneStateService.sipLayer.sendMessage(XML);	
          	    }
          	     catch(Throwable e){
          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
          	     }
	        	   Toast.makeText(context, "ready to dial", Toast.LENGTH_SHORT).show();
	        	   break;
	         
	           case TelephonyManager.CALL_STATE_OFFHOOK:
	        	   Toast.makeText(context, "established", Toast.LENGTH_SHORT).show();
	        	   break;
	         
	           case TelephonyManager.CALL_STATE_RINGING:
	           if(incomingNumber.length()==0){        	   
	        	   XML=GlobalRecord.XML1 + 
	        	   Repeat( ++GlobalRecord.Version,GlobalRecord.Dialog_id,phonenumber) + 
        	       "direction=\"recipient\">\n" + 
        	       "<state>confirmed</state>\n" + 
        	       "<remote>\n" + 
        	       "<identity>tel:+" + GlobalRecord.incomingNumber +"</identity>\n" + 
        	       " </remote>\n" + 
        	       "</dialog>\n" +
                   "</dialog-info>\n";
        	   System.out.print(XML);
        	   try{
          	     PhoneStateService.sipLayer.sendMessage(XML);	
          	   }
          	     catch(Throwable e){
          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
          	     }
	        	   
	        	 Toast.makeText(context, "established from ringing", Toast.LENGTH_SHORT).show();
	        	 }
	        	else
	        	Toast.makeText(context, "cutoff from ringing", Toast.LENGTH_SHORT).show();
	        	break;
	    	  
	      }
		    break;
		    
		    case TelephonyManager.CALL_STATE_RINGING:
		    	GlobalRecord.incomingNumber=incomingNumber;
		      Log.d("DEBUG", "RINGING");
		      Toast.makeText(context, "RINGING Status", Toast.LENGTH_SHORT).show();
		      
		      switch(GlobalRecord.PreviousState){
	         
		        case TelephonyManager.CALL_STATE_IDLE:
	        	   XML=GlobalRecord.XML1 + 
	        	   Repeat( ++GlobalRecord.Version,++GlobalRecord.Dialog_id,phonenumber) + 
	        	       "direction=\"recipient\">\n" + 
	        	       "<state>early</state>\n" + 
	        	       "<remote>\n" + 
	        	       "<identity>tel:+"+incomingNumber+"</identity>\n" + 
	        	       " </remote>\n" + 
	        	       "</dialog>\n" +
                       "</dialog-info>\n";
	        	   System.out.print(XML);
	        	   try{
	          	     PhoneStateService.sipLayer.sendMessage(XML);	
	          	    }
	          	     catch(Throwable e){
	          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
	          	     }
	        	   Toast.makeText(context, "Coming Call", Toast.LENGTH_SHORT).show();
	        	   break;
	        	   
	           case TelephonyManager.CALL_STATE_OFFHOOK:
	        	   XML=GlobalRecord.XML1 + 
	        	   Repeat( ++GlobalRecord.Version,++GlobalRecord.Dialog_id,phonenumber) + 
        	       "direction=\"recipient\">\n" + 
        	       "<state>early</state>\n" + 
        	       "<remote>\n" + 
        	       "<identity>tel:+"+incomingNumber+"</identity>\n" + 
        	       " </remote>\n" + 
        	       "</dialog>\n" +
                   "</dialog-info>\n";
        	   System.out.print(XML);
        	   try{
          	     PhoneStateService.sipLayer.sendMessage(XML);	
          	    }
          	     catch(Throwable e){
          		 Log.e("sip","ERROR sending message: " + e.getMessage() + "\n");
          	     }
	        	   Toast.makeText(context, "Another Call", Toast.LENGTH_SHORT).show();
	        	   break;
	        	   
	           case TelephonyManager.CALL_STATE_RINGING:	
	        	   Toast.makeText(context, "RINGING Nothing", Toast.LENGTH_SHORT).show();
	        	   break;
	    	  
	      }
		    break;
		    }
		         GlobalRecord.PreviousState = state;
		  }
	
	public String Repeat(int version, int dialog, String number){
		Repeat1="version=\""+ version +"\"\n" + 
	       "state=\"partial\"\n" +
	       "entity=\"tel:+"+number+"\">\n" + 
	       "<dialog id=\""+ dialog +"\"\n";
		return Repeat1;
	}
	
	 
}
