package com.sece.android;

import java.io.IOException;
import java.util.Random;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

/*
 * The control panel for the service, you can start and stop the service here.
 * Especially when it is the first time you start to use this application you
 * will have to register from the server first. After you press the register button
 * it will lead you to the registration website where you can get a registration code
 * there, it will be used for the information communication afterward.
 */
public class SECEserviceActivity extends Activity {
    /** Called when the activity is first created. */
   private Button mConnectButton;
   private Button mDisconnectButton;
   private Button mRegisterButton;
   private Random rand = new Random();
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //if not registered yet
        if(GlobalRecord.code==null)
        {                       
        setContentView(R.layout.main);
        View b1 = findViewById(R.id.button_connect);
        b1.setVisibility(View.INVISIBLE);
        View b2 = findViewById(R.id.button_disconnect);
        b2.setVisibility(View.INVISIBLE);
        }
        //if you have already registered for the service
        else{
        setContentView(R.layout.main);
        View b3 = findViewById(R.id.button_register);
        b3.setVisibility(View.INVISIBLE);
        }
    }
	@Override
	public void onStart(){
		super.onStart();
   	     mConnectButton = (Button) findViewById(R.id.button_connect);
         mConnectButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                // Send a message using content of the edit text widget            
            	Intent intent = new Intent(new Intent(SECEserviceActivity.this,
                        PhoneStateService.class));	
            	startService(intent);
            }
        });
        mDisconnectButton = (Button) findViewById(R.id.button_disconnect);
        mDisconnectButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                // Send a message using content of the edit text widget            
            	Intent intent = new Intent(new Intent(SECEserviceActivity.this,
                        PhoneStateService.class));	
            	stopService(intent);
            }
        });
        mRegisterButton = (Button) findViewById(R.id.button_register);
        mRegisterButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
            	//randomly start a port listen to the redirect respond from
            	//the browser inside the phone to hand in the registration code
            	int port = rand.nextInt(65535-1024)+1024;
                try {
        			Thread cThread = new Thread(new TCPClient(port));
        			cThread.start();
        			
        		} catch (IOException e) {
        			// TODO Auto-generated catch block
        			e.printStackTrace();
        		}
        		//start the browser inside the phone with the following 
        		//registration url
            	 Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse("http://lagrange.cs.columbia.edu/oauth2/authorize?response_type=code&client_id=dfdfd&redirect_uri=http://127.0.0.1:"+port));
                 startActivity(browserIntent);
            }
        });
	}
}