package com.sece.android;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import android.util.Base64;
/*
 * TCP connection which will listen to the random port in case there will be
 * a connection from the browser to send the registration code and then we will
 * encode the code string as BASE64 format and store it in the GlobalRecord. Then
 * we will be marked as registered. And then we can use the service afterward. 
 */
public class TCPClient implements Runnable{
  private ServerSocket serverSocket;	
  public TCPClient(int port) throws IOException{
	  serverSocket = new ServerSocket(port);
	  serverSocket.setSoTimeout(10000000);
	  
  }
  public void run(){
	  while(true)
      {
         try
         {
            System.out.println("Waiting for client on port " +
            serverSocket.getLocalPort() + "...");
            
            Socket server = serverSocket.accept();
            System.out.println("Just connected to "
                  + server.getRemoteSocketAddress());
            DataInputStream in =
                  new DataInputStream(server.getInputStream());
            String request = in.readLine(); 
            //get the registration code
            int a = request.indexOf("code", 0);
            int b = request.indexOf("HTTP", 0);
            String code= request.substring(a+5, b-1);
            byte[] theByteCode=code.getBytes();
            //encode it to the BASE64 format
            GlobalRecord.code = Base64.encodeToString(theByteCode,Base64.DEFAULT);
            GlobalRecord.code = GlobalRecord.code.substring(0, GlobalRecord.code.length()-1);
            System.out.println(GlobalRecord.code+"rr");
            
            DataOutputStream out =
                 new DataOutputStream(server.getOutputStream());
            out.writeUTF("Thank you for connecting to "
              + server.getLocalSocketAddress() + "\nGoodbye!");
            server.close();
            if(GlobalRecord.code!=null)
            	break;
         }catch(SocketTimeoutException s)
         {
            System.out.println("Socket timed out!");
            break;
         }catch(IOException e)
         {
            e.printStackTrace();
            break;
         }
      }

  }

}
